﻿--[[
	Copyright (c) 2009, dr_AllCOM3
    All rights reserved.

    You're allowed to use this addon, free of monetary charge,
    but you are not allowed to modify, alter, or redistribute
    this addon without express, written permission of the author.
]]

local L = LibStub( "AceLocale-3.0" ):GetLocale( "DocsDebugRunes" )
local LSM = LibStub( "LibSharedMedia-3.0" )
local addon = DocsDebugRunes
local db, temp, temp2

local function p( text ) -- Print
	ChatFrame3:AddMessage( tostring( text ) )
end

local optionsGeneral = {
    name = L["Layout"],
    desc = L["Layout"],
    type = "group",
    order = 1,
    args = {
        lock = {
            type="execute",
            name = L["Unlock"],
            desc = L["Unlock"],
            func=function( self )
                InterfaceOptionsFrame:Hide()
                
                addon:locked()
            end,
            order=1,
        },
        header0 = {
            name = "",
            type = "header",
            order = 2,
        },
        
        enableDiseases = {
            type = "toggle",
            name = L["Diseases"],
            desc = L["Diseases"],
            order = 10,
            get=function() return db.enableDiseases end,
            set=function()
                    db.enableDiseases = not db.enableDiseases
                    addon:CreateFrames()
                end,
        },
        enableDarkTransformation = {
            type = "toggle",
            name = L["Dark Transformation"],
            desc = L["Dark Transformation"],
            order = 11,
            get=function() return db.enableDarkTransformation end,
            set=function()
                    db.enableDarkTransformation = not db.enableDarkTransformation
                    addon:CreateFrames()
                end,
        },
        enableRunicPower = {
            type = "toggle",
            name = L["Runic Power"],
            desc = L["Runic Power"],
            order = 12,
            get=function() return db.enableRunicPower end,
            set=function()
                    db.enableRunicPower = not db.enableRunicPower
                    addon:CreateFrames()
                    addon:UNIT_POWER( _, "player", _ )
                end,
        },
        enableProcs = {
            type = "toggle",
            name = L["Procs"],
            desc = L["Procs"],
            order = 13,
            get=function() return db.enableProcs end,
            set=function()
                    db.enableProcs = not db.enableProcs
                    addon:CreateFrames()
                end,
        },
        enableBloodShield = {
            type = "toggle",
            name = L["Blood Shield"],
            desc = L["Blood Shield"],
            order = 14,
            get=function() return db.enableBloodShield end,
            set=function()
                    db.enableBloodShield = not db.enableBloodShield
                    addon:CreateFrames()
                end,
        },
        enableDeathStrikeHeal = {
            type = "toggle",
            name = L["Death Strike"],
            desc = L["Death Strike"],
            order = 15,
            get=function() return db.enableDeathStrikeHeal end,
            set=function()
                    db.enableDeathStrikeHeal = not db.enableDeathStrikeHeal
                    addon:CreateFrames()
                end,
        },
        
        header1 = {
            name = L["Layout"],
            type = "header",
            order = 80,
        },
        width = {
            name = L["Width"],
            desc = L["Width"],
            type = "range",
            min = 5,
            max = 200,
            step = 1,
            order = 81,
            get=function() return db.width end,
            set=function(self, val)
                    db.width = val
                    addon:CreateFrames()
                end,
        },
        height = {
            name = L["Height"],
            desc = L["Height"],
            type = "range",
            min = 1,
            max = 50,
            step = 1,
            order = 82,
            get=function() return db.height end,
            set=function(self, val)
                    db.height = val
                    addon:CreateFrames()
                end,
        },
        oocAlpha = {
            name = L["OOC Transparency"],
            desc = L["OOC Transparency"],
            type = "range",
            min = 0,
            max = 1,
            step = 0.05,
            order = 83,
            get=function() return db.oocAlpha end,
            set=function(self, val)
                    db.oocAlpha = val
                    addon:CreateFrames()
                end,
        },
        runeOrder = {
            name = L["Rune order"],
            desc = L["Rune order"],
            type = "select",
            style = "radio",
            values = { "UFB", "BFU", "FBU" },
            order = 84,
            get=function() return db.runeOrder end,
            set=function( self, val )
                    db.runeOrder = val
                    addon:CreateFrames()
                end,
        },
        
        header2 = {
            name = L["Font"],
            type = "header",
            order = 90,
        },
        fontsize = {
            name = L["Font Size"],
            desc = L["Font Size"],
            type = "range",
            min = 5,
            max = 50,
            step = 1,
            order = 91,
            get=function() return db.fontsize end,
            set=function(self, val)
                    db.fontsize = val
                    addon:CreateFrames()
                end,
        },
        font = {
            type = "select",
            name = L["Font"],
            desc = L["Font"],
            values = LSM:HashTable("font"),
            dialogControl = "LSM30_Font",
            order = 92,
            get=function() return db.font end,
            set=function(self, val)
                    db.font = val
                    addon:CreateFrames()
                end,
        },
        
        header3 = {
            name = L["Textures"],
            type = "header",
            order = 100,
        },
        texture = {
            type = "select",
            name = L["Statusbar"],
            desc = L["Statusbar"],
            values = LSM:HashTable("statusbar"),
            dialogControl = "LSM30_Statusbar",
            order = 101,
            get=function() return db.texture end,
            set=function(self, val)
                    db.texture = val
                    addon:CreateFrames()
                end,
        },
        border = {
            type = "select",
            name = L["Border"],
            desc = L["Border"],
            values = LSM:HashTable("border"),
            dialogControl = "LSM30_Border",
            order = 102,
            get=function() return db.border end,
            set=function(self, val)
                    db.border = val
                    addon:CreateFrames()
                end,
        },
    }
}

-- Spawn the options
function DocsDebugRunes:SpawnOptions()
    db = DocsDebugRunes.db.profile
    
    DocsDebugRunes.options = {
        type = "group",
        handler = DocsDebugRunes,
        args = {
            optionsGeneral = optionsGeneral,
        },
    }
end

